## libc++ 1.0~svn181765

=== debian/changelog ===
libc++ (1.0~svn181765-1) unstable; urgency=low

  * New snapshot release
  * Upload to unstable

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 14 May 2013 10:41:44 +0200

libc++ (1.0~svn180177-1~exp1) experimental; urgency=low

  * New upstream release
  * Minimal clang version (>= 3.2)
  * Standards-Version updated to version 3.9.4

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 24 Apr 2013 09:32:41 +0200

libc++ (1.0~svn170866-1~exp1) experimental; urgency=low

  * New snapshot release
  * libc++-dev now provides libstdc++-dev
  * Update of the homepage
  * Update the minimal version of debhelper (9)

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 21 Dec 2012 09:45:40 +0100

libc++ (1.0~svn161106-1~exp1) experimental; urgency=low

  * New snapshot release

  [ Andrej Belym ]
  * Multiarch support.

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 01 Aug 2012 10:38:08 +0200

libc++ (1.0~svn160132-1~exp1) experimental; urgency=low

  * Initial release (Closes: #682245)

 -- Andrej Belym <white.wolf.2105@gmail.com>  Sat, 02 Jun 2012 19:25:47 +0400
