=== debian/control ===
Source: libc++
Priority: extra
Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
Uploaders: Andrej Belym <white.wolf.2105@gmail.com>,
 Sylvestre Ledru <sylvestre@debian.org>
Build-Depends: debhelper (>= 9.0.0), clang (>= 1:3.2), dh-exec
Standards-Version: 3.9.4
Section: libs
Homepage: http://libcxx.llvm.org/
Vcs-Svn: svn://svn.debian.org/svn/pkg-llvm/libcxx/trunk/
Vcs-Browser: http://svn.debian.org/viewsvn/pkg-llvm/libcxx/trunk/

Package: libc++1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: clang
Description: LLVM C++ Standard library
 libc++ is a new implementation of the C++ standard library, targeting C++11.
 .
 Features and Goals
 .
   * Correctness as defined by the C++11 standard.
   * Fast execution.
   * Minimal memory use.
   * Fast compile times.
   * ABI compatibility with gcc's libstdc++ for some low-level features such
     as exception objects, rtti and memory allocation.
   * Extensive unit tests.

Package: libc++-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libc++1 (= ${binary:Version}), ${misc:Depends}
Provides: libstdc++-dev
Description: LLVM C++ Standard library (development files)
 libc++ is a new implementation of the C++ standard library, targeting C++11.
 .
 Features and Goals
 .
   * Correctness as defined by the C++11 standard.
   * Fast execution.
   * Minimal memory use.
   * Fast compile times.
   * ABI compatibility with gcc's libstdc++ for some low-level features such
     as exception objects, rtti and memory allocation.
   * Extensive unit tests.

Package: libc++-src
Section: libs
Architecture: any
Depends: libc++1 (= ${binary:Version}), ${misc:Depends}
Description: LLVM C++ Standard library (source and test cases)
 libc++ is a new implementation of the C++ standard library, targeting C++11.
 .
 Features and Goals
 .
   * Correctness as defined by the C++11 standard.
   * Fast execution.
   * Minimal memory use.
   * Fast compile times.
   * ABI compatibility with gcc's libstdc++ for some low-level features such
     as exception objects, rtti and memory allocation.
   * Extensive unit tests.
 .
 This package contains the sources and test cases of libc++ library.

Package: libc++abi1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: LLVM low level support for a standard C++ library
 libc++abi is a new implementation of low level support for a standard C++
 library.
 .
 Features and Goals
 .
   * Correctness as defined by the C++11 standard.
   * Provide a portable sublayer to ease the porting of libc++
 .

Package: libc++abi-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libc++abi1 (= ${binary:Version}), ${misc:Depends}
Description: LLVM low level support for a standard C++ library (development files)
 libc++abi is a new implementation of low level support for a standard C++
 library.
 .
 Features and Goals
 .
   * Correctness as defined by the C++11 standard.
   * Provide a portable sublayer to ease the porting of libc++
 .

Package: libc++abi-src
Section: libs
Architecture: any
Depends: libc++abi1 (= ${binary:Version}), ${misc:Depends}
Description: libc++abi source and test cases
 libc++abi is a new implementation of low level support for a standard C++
 library.
 .
 Features and Goals
 .
   * Correctness as defined by the C++11 standard.
   * Provide a portable sublayer to ease the porting of libc++
 .
 Sources and test cases of libc++abi library.
