## libc++ 1.0~svn199600

=== debian/changelog ===
libc++ (1.0~svn199600-1) unstable; urgency=low

  * New snapshot release
  * Standards-Version updated to 3.9.5
  * Introduce package libc++-helpers (Closes: #718637)
  * Rename libc++-src => libc++-test
  * Rename libc++abi-src => libc++abi-test
  * For both, remove the sources from the packages (apt-get source libc++)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 19 Jan 2014 15:25:24 +0100

libc++ (1.0~svn196040-1) unstable; urgency=low

  * New snapshot release

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 01 Dec 2013 11:00:53 +0100

libc++ (1.0~svn189766-1) unstable; urgency=low

  * New snapshot release

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 02 Sep 2013 19:43:49 +0200
