=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Uploaders: Andrej Belym <white.wolf.2105@gmail.com>,
  Sylvestre Ledru <sylvestre@debian.org>
 Build-Depends: debhelper (>= 9.0.0), clang (>= 1:3.2), dh-exec
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Section: libs
 Homepage: http://libcxx.llvm.org/
 Vcs-Svn: svn://svn.debian.org/svn/pkg-llvm/libcxx/trunk/
@@ -34,7 +34,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libc++1 (= ${binary:Version}), ${misc:Depends}
+Depends: libc++1 (= ${binary:Version}), ${misc:Depends}, libc++-helpers
 Provides: libstdc++-dev
 Description: LLVM C++ Standard library (development files)
  libc++ is a new implementation of the C++ standard library, targeting C++11.
@@ -49,11 +49,13 @@
      as exception objects, rtti and memory allocation.
    * Extensive unit tests.
 
-Package: libc++-src
+Package: libc++-test
 Section: libs
 Architecture: any
 Depends: libc++1 (= ${binary:Version}), ${misc:Depends}
-Description: LLVM C++ Standard library (source and test cases)
+Replaces: libc++-src (<< 1.0~svn199600-1)
+Breaks: libc++-src (<< 1.0~svn199600-1)
+Description: LLVM C++ Standard library (test cases)
  libc++ is a new implementation of the C++ standard library, targeting C++11.
  .
  Features and Goals
@@ -66,7 +68,7 @@
      as exception objects, rtti and memory allocation.
    * Extensive unit tests.
  .
- This package contains the sources and test cases of libc++ library.
+ This package contains the test cases of libc++ library.
 
 Package: libc++abi1
 Section: libs
@@ -99,11 +101,13 @@
    * Provide a portable sublayer to ease the porting of libc++
  .
 
-Package: libc++abi-src
+Package: libc++abi-test
 Section: libs
 Architecture: any
 Depends: libc++abi1 (= ${binary:Version}), ${misc:Depends}
-Description: libc++abi source and test cases
+Replaces: libc++abi-src (<< 1.0~svn199600-1)
+Breaks: libc++abi-src (<< 1.0~svn199600-1)
+Description: libc++abi test cases
  libc++abi is a new implementation of low level support for a standard C++
  library.
  .
@@ -112,4 +116,26 @@
    * Correctness as defined by the C++11 standard.
    * Provide a portable sublayer to ease the porting of libc++
  .
- Sources and test cases of libc++abi library.
+ Test cases of libc++abi library.
+
+
+Package: libc++-helpers
+Architecture: all
+Multi-Arch: foreign
+Depends: ${misc:Depends}
+Replaces: libc++-dev (<< 1.0~svn199600-1)
+Breaks: libc++-dev (<< 1.0~svn199600-1)
+Description: LLVM C++ Standard library - build helpers
+ libc++ is a new implementation of the C++ standard library, targeting C++11.
+ .
+ Features and Goals
+ .
+   * Correctness as defined by the C++11 standard.
+   * Fast execution.
+   * Minimal memory use.
+   * Fast compile times.
+   * ABI compatibility with gcc's libstdc++ for some low-level features such
+     as exception objects, rtti and memory allocation.
+   * Extensive unit tests.
+ .
+ This package contains the build helpers (clang++-libc++, etc)
