## libc++ 3.5

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -32,7 +32,7 @@
 endif()
 
 if (DEFINED LIBCXX_CXX_ABI_DEPS)
-  add_dependencies(cxx ${LIBCXX_CXX_ABI_DEPS})
+  add_dependencies(cxx LIBCXX_CXX_ABI_DEPS)
 endif()
 
 # Generate library list.
