=== debian/changelog ===
libc++ (3.5-2) unstable; urgency=medium

  * Remove a useless patch libcxx-use_libcxxabi.patch (Closes: #762354)
  * g++-libc++ helper now manages option -pthread (Closes: #760542)
    Thanks to Miles Bader for the patch
  * Fix the FTBFS under ARM/ARMHF by disabling the ARM EHABI exception handling
    (Closes: #761193)
  * Fails the build in case of error
  * Fix some files layout issues

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 28 Sep 2014 23:01:19 +0200

libc++ (3.5-1) unstable; urgency=medium

  * New upstream release
  * Now that libcxxabi is also official released, use stable releases
  * Update of the repack script
  * syntax-error-in-dep5-copyright fixed
  * Depends on clang instead of clang-X.Y

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 03 Sep 2014 16:32:53 +0200

libc++ (1.0~svn216840-1) unstable; urgency=medium

  * New snapshot release
  * Update the dependency from clang-3.4 to clang (co install)
    (Closes: #759938)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 31 Aug 2014 11:32:59 +0200

libc++ (1.0~svn205159-1) unstable; urgency=medium

  * New snapshot release
  * Force the usage of clang 3.4 (Closes: #736991)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 30 Mar 2014 21:26:14 +0200
