=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
 Uploaders: Andrej Belym <white.wolf.2105@gmail.com>,
  Sylvestre Ledru <sylvestre@debian.org>
-Build-Depends: debhelper (>= 9.0.0), clang (>= 1:3.2), dh-exec
+Build-Depends: debhelper (>= 9.0.0), clang, dh-exec
 Standards-Version: 3.9.5
 Section: libs
 Homepage: http://libcxx.llvm.org/
